<?
/* ************************************************** */
function blog_xmlrpc() {
  return array("drupal.newBlog" => array("function" => "blog_xmlrpc_drupal_newBlog"),
               "drupal.editBlog" => array("function" => "blog_xmlrpc_drupal_editBlog"),
               "drupal.deleteBlog" => array("function" => "blog_xmlrpc_drupal_deleteBlog"),
               "blogger.newPost" => array("function" => "blog_xmlrpc_blogger_newPost"),
               "blogger.editPost" => array("function" => "blog_xmlrpc_blogger_editPost"),
               "blogger.deletePost" => array("function" => "blog_xmlrpc_blogger_deletePost"),
               "blogger.getUsersBlogs" => array("function" => "blog_xmlrpc_blogger_getUsersBlogs"),
               "blogger.getTemplate" => array("function" => "blog_xmlrpc_blogger_getTemplate"),
               "blogger.setTemplate" => array("function" => "blog_xmlrpc_blogger_setTemplate"),
               "blogger.getRecentPosts" => array("function" => "blog_xmlrpc_blogger_getRecentPosts"),
               "blogger.getPost" => array("function" => "blog_xmlrpc_blogger_getPost"),
               "blogger.getUserInfo" => array("function" => "blog_xmlrpc_blogger_getUserInfo")
               );
}

/* ************************************************** */
function xmlrpc_validate_user($userid, $password) {
  //Check the id, password and set up $user. We can't use user_init as it's a server and won't be using persistent sessions.
  global $user;

  if ($userid && $password) {
    $user = new User($userid, $passwd);
  }

  return ($user->id) ? true : false ;
}

/* ************************************************** */
function tt(){
  $tt = array_flip(get_html_translation_table(HTML_ENTITIES));
  $tt["&apos;"] = "'";
  return $tt;
}


/* ************************************************** */
function blog_xmlrpc_drupal_newBlog($params) {
  global $xmlrpcerruser, $status, $user;

  $sn0=$params->getParam(0);  $username = $sn0->scalarval();
  $sn1=$params->getParam(1);  $password = $sn1->scalarval();
  $sn2=$params->getParam(2);  $title = $sn2->scalarval();
  $sn3=$params->getParam(3);  $edit["body"] = $sn3->scalarval();

  $edit["title"]= strip_tags(strtr($title ? $title : substr(strip_tags(strtr($edit[body], tt() )), 0, 30), tt() ));

  if (!xmlrpc_validate_user($username, $password)) {
    $err = "Invalid user";
  } 
  else if (!user_access("post blogs")) {
    $err = "$username is not allowed to post blogs.";
  }
  else {
    $nid = blog_save($edit); // requires blog_save to return  the nid;
  }

  if (!empty($err)) {
    watchdog("warning", "xmlrpc: $err");
    return new xmlrpcresp(0, $xmlrpcerruser+1, $err);
  }
  else {
    return new xmlrpcresp(new xmlrpcval($nid, "string"));
  }
}

/* ************************************************** */
function blog_xmlrpc_drupal_editBlog($params) {
  global $xmlrpcerruser, $status, $user;

  $sn0=$params->getParam(0);  $username = $sn0->scalarval();
  $sn1=$params->getParam(1);  $password = $sn1->scalarval();
  $sn2=$params->getParam(2);  $edit[nid] = $sn2->scalarval();
  $sn3=$params->getParam(3);  $title = $sn3->scalarval();
  $sn4=$params->getParam(4);  $edit[body] = $sn4->scalarval();
  $edit[title] = strip_tags(strtr($title ? $title : substr(strip_tags(strtr($edit[body], tt() )), 0, 30), tt() ));

  if (!xmlrpc_validate_user($username, $password)) {
    $err = t("Invalid user");
  } 
  else if (!user_access("post blogs")) {
    $err = "$username is not allowed to post blogs.";
  }
  else {
    $node = db_fetch_object(db_query("SELECT * FROM node WHERE nid = '".$edit[nid]."'"));
    if (($node->author == $user->id) || user_access("administer blogs")) {
      blog_save($edit);
    } else {
      $err = t("You do not have access to that blog");
    }
  }

  if (!empty($err)) {            // this is an error condition
    return new xmlrpcresp(0, $xmlrpcerruser+1, $err);
  }
  else {
    return new xmlrpcresp(new xmlrpcval(true, "boolean"));
  }
}

/* ************************************************** */
function blog_xmlrpc_drupal_deleteBlog($params) {
  global $xmlrpcerruser, $status, $user;

  $sn0=$params->getParam(0);  $username = $sn0->scalarval();
  $sn1=$params->getParam(1);  $password = $sn1->scalarval();
  $sn2=$params->getParam(2);  $nid = $sn2->scalarval();

  if (!xmlrpc_validate_user($username, $password)) {
    $err = t("Invalid user");
  } 
  else if (!user_access("post blogs")) {
    $err = "$username is not allowed to post blogs.";
  }
  else {
    if ($node = db_fetch_object(db_query("SELECT * FROM node WHERE nid = '$nid'"))) {
      if (($node->author == $user->id) || user_access("administer blogs")) {
        blog_remove($nid);
      } else {
        $err = t("You do not have access to that blog");
      }
    }
    else {
      $err = t("Blog ".$edit[nid]." not found");
    }
  }

  if (!empty($err)) {            // this is an error condition
    return new xmlrpcresp(0, $xmlrpcerruser+1, $err);
  }
  else {
    return new xmlrpcresp(new xmlrpcval(true, "boolean"));
  }
}

/* ************************************************** */
function blog_xmlrpc_blogger_newPost($params) {
//Posts a new blog, appkey is discarded,
//blogid is the same as userid, Publish is always true
//Matches blogger.newPost, Documentation at http://plant.blogger.com/api/
  global $xmlrpcerruser, $status, $user;

  $sn0=$params->getParam(0);  $appkey   = $sn0->scalarval();
  $sn1=$params->getParam(1);  $blogid   = $sn1->scalarval();
  $sn2=$params->getParam(2);  $username = $sn2->scalarval();
  $sn3=$params->getParam(3);  $password = $sn3->scalarval();
  $sn4=$params->getParam(4);  $edit[body] = $sn4->scalarval();
  $sn5=$params->getParam(5);  $publish = $sn5->scalarval();

  $title = "";
  $edit[title] = strip_tags(strtr($title ? $title : substr(strip_tags(strtr($edit[body], tt() )), 0, 30), tt() ));

  if (!xmlrpc_validate_user($username, $password)) {
    $err = "Invalid user";
  } 
  else if (!user_access("post blogs")) {
    $err = "$username is not allowed to post blogs.";
  }
  else {
    $nid = blog_save($edit); // requires blog_save to return  the nid;
  }

  if (!empty($err)) {
    watchdog("warning", "xmlrpc: $err");
    return new xmlrpcresp(0, $xmlrpcerruser+1, $err);
  }
  else {
    return new xmlrpcresp(new xmlrpcval($nid, "string"));
  }
}

/* ************************************************** */
function blog_xmlrpc_blogger_editPost($params) {
//Posts a changed blog, appkey is discarded, 
//Publish is always true
//Matches blogger.editPost, Documentation at http://plant.blogger.com/api/
  global $xmlrpcerruser, $status, $user;

  $sn0=$params->getParam(0);  $appkey   = $sn0->scalarval();
  $sn1=$params->getParam(1);  $edit[nid] = $sn1->scalarval();
  $sn2=$params->getParam(2);  $username = $sn2->scalarval();
  $sn3=$params->getParam(3);  $password = $sn3->scalarval();
  $sn4=$params->getParam(4);  $edit[body] = $sn4->scalarval();
  $sn5=$params->getParam(5);  $publish = $sn5->scalarval();
  $title = "";
  $edit[title] = strip_tags(strtr($title ? $title : substr(strip_tags(strtr($edit[body], tt() )), 0, 30), tt() ));

  if (!xmlrpc_validate_user($username, $password)) {
    $err = t("Invalid user");
  } 
  else if (!user_access("post blogs")) {
    $err = "$username is not allowed to post blogs.";
  }
  else {
    $node = db_fetch_object(db_query("SELECT * FROM node WHERE nid = '".$edit[nid]."'"));
    if (($node->author == $user->id) || user_access("administer blogs")) {
      blog_save($edit);
    } else {
      $err = t("You do not have access to that blog");
    }
  }

  if (!empty($err)) {            // this is an error condition
    return new xmlrpcresp(0, $xmlrpcerruser+1, $err);
  }
  else {
    return new xmlrpcresp(new xmlrpcval(true, "boolean"));
  }
}

/* ************************************************** */
function blog_xmlrpc_blogger_deletePost($params) {
//Deletes a blog item, appkey is discarded, 
//Publish is always true
//Matches blogger.deletePost, Documentation at http://groups.yahoo.com/group/bloggerDev/message/147
  global $xmlrpcerruser, $status, $user;

  $sn0=$params->getParam(0);  $appkey   = $sn0->scalarval();
  $sn1=$params->getParam(1);  $nid = $sn1->scalarval();
  $sn2=$params->getParam(2);  $username = $sn2->scalarval();
  $sn3=$params->getParam(3);  $password = $sn3->scalarval();
  $sn4=$params->getParam(4);  $publish = $sn4->scalarval();

  if (!xmlrpc_validate_user($username, $password)) {
    $err = t("Invalid user");
  } 
  else if (!user_access("post blogs")) {
    $err = "$username is not allowed to post blogs.";
  }
  else {
    if ($node = db_fetch_object(db_query("SELECT * FROM node WHERE nid = '$nid'"))) {
      if (($node->author == $user->id) || user_access("administer blogs")) {
        blog_remove($nid);
      } else {
        $err = t("You do not have access to that blog");
      }
    }
    else {
      $err = t("Blog ".$edit[nid]." not found");
    }
  }

  if (!empty($err)) {            // this is an error condition
    return new xmlrpcresp(0, $xmlrpcerruser+1, $err);
  }
  else {
    return new xmlrpcresp(new xmlrpcval(true, "boolean"));
  }
}

/* ************************************************** */
function blog_xmlrpc_blogger_getUsersBlogs($params) {
//For compatibility Only. Not much use for Drupal.
//Matches blogger.getUsersBlogs, Documentation at http://plant.blogger.com/api/
  global $xmlrpcerruser, $status, $user;

  $sn0=$params->getParam(0);  $appkey   = $sn0->scalarval();
  $sn1=$params->getParam(1);  $username = $sn1->scalarval();
  $sn2=$params->getParam(2);  $password = $sn2->scalarval();

  if (!xmlrpc_validate_user($username, $password)) {
    $err = "Invalid user";
  } 
  else if (!user_access("access blogs")) {
    $err = "$username is not allowed to access blogs.";
  }
  else {
    $struct = new xmlrpcval(array("url" => new xmlrpcval(path_uri() . "module.php?mod=blog&op=view&name=". urlencode($user->name)),
                                  "blogid" => new xmlrpcval($user->id),
                                  "blogName" => new xmlrpcval($user->name . "'s blog at ". variable_get("site_name", "drupal"))
                                  ),"struct");
    $resp = new xmlrpcval(array($struct), "array");
  }

  if (!empty($err)) {
    watchdog("warning", "xmlrpc: $err");
    return new xmlrpcresp(0, $xmlrpcerruser+1, $err);
  }
  else {
    return new xmlrpcresp($resp);
  }
}

/* ************************************************** */
function blog_xmlrpc_blogger_getTemplate($params) {
//For compatibility Only. Not much use for Drupal.
//Matches blogger.getTemplate, Documentation at http://plant.blogger.com/api/
  $err = t("Get Template is not relevant for Drupal");
  return new xmlrpcresp(0, $xmlrpcerruser+1, $err);
}

/* ************************************************** */
function blog_xmlrpc_blogger_setTemplate($params) {
//For compatibility Only. Not much use for Drupal.
//Matches blogger.setTemplate, Documentation at http://plant.blogger.com/api/
  $err = t("Set Template is not relevant for Drupal");
  return new xmlrpcresp(0, $xmlrpcerruser+1, $err);
}

/* ************************************************** */
function blog_xmlrpc_blogger_getRecentPosts($params) {
//Gets an array of post structs, appkey is discarded,
//blogid is ignored
//Matches blogger.getRecentPosts, Documentation at http://groups.yahoo.com/group/bloggerDev/message/225
  global $xmlrpcerruser, $status, $user;

  $sn0=$params->getParam(0);  $appkey   = $sn0->scalarval();
  $sn1=$params->getParam(1);  $blogid   = $sn1->scalarval();
  $sn2=$params->getParam(2);  $username = $sn2->scalarval();
  $sn3=$params->getParam(3);  $password = $sn3->scalarval();
  $sn4=$params->getParam(4);  $numberOfPosts = $sn4->scalarval();
  if (($numberOfPosts == 0) or ($numberOfPosts > 100)) $numberOfPosts = 50; 

  if (!xmlrpc_validate_user($username, $password)) {
    $err = "Invalid user";
  } 
  else if (!user_access("access blogs")) {
    $err = "$username is not allowed to access blogs.";
  }
  else {
    $thearray = array();
    $result = db_query("SELECT n.*, b.body FROM blog b LEFT JOIN node n ON b.nid = n.nid LEFT JOIN users u ON n.author = u.id WHERE u.userid = '$username' ORDER BY b.lid DESC LIMIT ".$numberOfPosts);
    while ($blog = db_fetch_object($result)) {
      $thearray[] = new xmlrpcval(array("userid" => new xmlrpcval($blog->author,"string"),
                                  "dateCreated" => new xmlrpcval(iso8601_encode($blog->timestamp),"dateTime.iso8601"),
                                  "content" => new xmlrpcval($blog->body,"string"),
                                  "postid" => new xmlrpcval($blog->nid,"string")
                                  ), "struct");
    }
    $resp = new xmlrpcval($thearray, "array");
  }

  if (!empty($err)) {
    watchdog("warning", "xmlrpc: $err");
    return new xmlrpcresp(0, $xmlrpcerruser+1, $err);
  }
  else {
    return new xmlrpcresp($resp);
  }
}

/* ************************************************** */
function blog_xmlrpc_blogger_getPost($params) {
//Gets a struct of a single blog item
//Matches blogger.getPost, Documentation at http://groups.yahoo.com/group/bloggerDev/message/296
  global $xmlrpcerruser, $status, $user;

  $sn0=$params->getParam(0);  $appkey   = $sn0->scalarval();
  $sn1=$params->getParam(1);  $nid   = $sn1->scalarval();
  $sn2=$params->getParam(2);  $username = $sn2->scalarval();
  $sn3=$params->getParam(3);  $password = $sn3->scalarval();

  if (!xmlrpc_validate_user($username, $password)) {
    $err = "Invalid user";
  } 
  else if (!user_access("access blogs")) {
    $err = "$username is not allowed to access blogs.";
  }
  else {
    $blog = db_fetch_object(db_query("SELECT n.*, b.body FROM blog b LEFT JOIN node n ON b.nid = n.nid LEFT JOIN users u ON n.author = u.id WHERE n.nid = '$nid'"));
    $resp = new xmlrpcval(array("userid" => new xmlrpcval($blog->author,"string"),
                                "dateCreated" => new xmlrpcval(iso8601_encode($blog->timestamp),"dateTime.iso8601"),
                                "content" => new xmlrpcval($blog->body,"string"),
                                "postid" => new xmlrpcval($blog->nid,"string")
                                ), "struct");
  }

  if (!empty($err)) {
    watchdog("warning", "xmlrpc: $err");
    return new xmlrpcresp(0, $xmlrpcerruser+1, $err);
  }
  else {
    return new xmlrpcresp($resp);
  }
}

/* ************************************************** */
function blog_xmlrpc_blogger_getUserInfo($params) {
//Gets a struct of user info
//Matches blogger.getUserInfo, Documentation at http://groups.yahoo.com/group/bloggerDev/message/315

  global $xmlrpcerruser, $status, $user;

  $sn0=$params->getParam(0);  $appkey   = $sn0->scalarval();
  $sn1=$params->getParam(1);  $username = $sn1->scalarval();
  $sn2=$params->getParam(2);  $password = $sn2->scalarval();

  if (!xmlrpc_validate_user($username, $password)) {
    $err = "Invalid user";
  } 
  else {
    $theuser = db_fetch_object(db_query("SELECT * FROM users WHERE userid = '$username'"));
    $resp = new xmlrpcval(array("nickname" => new xmlrpcval($user->userid, "string"),
                                "userid" => new xmlrpcval($user->id, "string"),
                                "url" => new xmlrpcval(path_uri() . "module.php?mod=blog&op=view&name=". urlencode($user->name), "string"),
                                "email" => new xmlrpcval($user->real_email, "string"),
                                "lastname" => new xmlrpcval(substr($user->name, strrpos($user->name," ")+1), "string"),
                                "firstname" => new xmlrpcval(substr($user->name, 0, strrpos($user->name," ")), "string"),
                                ), "struct");
  }

  if (!empty($err)) {
    watchdog("warning", "xmlrpc: $err");
    return new xmlrpcresp(0, $xmlrpcerruser+1, $err);
  }
  else {
    return new xmlrpcresp($resp);
  }
}

?>
